#!/usr/bin/env python


import xml
from xml.etree import ElementTree
import os
import sys
import time
import re
import StringIO

class Rec:
    pass


def _strint(score):
    if score == "--":
        return -1
    return int(score)

def parse(line):
    retval = Rec()
    fields = line.strip().split(";");
    retval.time = float(fields[0])
    retval.team = fields[1]
    retval.scores = tuple([ tuple(map(int, x.split("/"))) for x in fields[2:]])
    return retval

def die(msg):
    sys.stderr.write(msg)
    sys.stderr.write("\n")
    sys.exit(-1)

def write_board(destfile, board_teams, log_teams, num_probs):
    board_teams.update(log_teams)
    out = open(destfile, "w")
    out.write("""<html>
  <head>
    <meta http-equiv="refresh" content="15"/>
    <title>Summary/Time - Contest</title>
  </head>
  <body>
  <table border="1">
  <tr>
""")
    #FIXME:  Should pull the problem names from the scoreboard, rather than assuming A-whatever?
    prob_title = 'A'
    for i in range(0, num_probs):
        out.write("    <th><b>" + prob_title + "</b></th>\n")
        prob_title = chr(ord(prob_title) + 1)
        
    allscores = [[x, board_teams[x]] for x in board_teams.keys()]
    
    
    

    out.write("<html>")
    out.close()


def main():
    if len(sys.argv) != 4:
        die("Usage: " +  os.path.basename(sys.argv[0]) + " <log file> <sumtime.html file> <output html>")
    sumtime = sys.argv[2]
    destfile = sys.argv[3]
    f = open(sys.argv[1], "r")
    logged_teams = {}

    header = f.readline().strip().split(" ")
    if (len(header) != 2 or header[0] != "LOGPC2"):
        die("Invalid header on replay file")

    replay_base_time = float(header[1])
    start_time = time.time()

    next_log_time = -1

    prev_mod_time = 0

    num_probs = -1

    while True:
        need_update = False
        if next_log_time:
            time.sleep(max(0, min(next_log_time - time.time(), 1)))
        else:
            time.sleep(1)
        if next_log_time and (time.time() >= next_log_time):
                l = f.readline()
                if l == "":
                    f.close()
                    next_log_time = 0
                else:
                    rec = parse(l)
                    next_log_time = start_time + (rec.time - replay_base_time)
                    logged_teams[rec.team] = rec.scores
                    if num_probs == -1:
                        num_probs = len(logged_teams[logged_teams.keys()[0]])
                    need_update = True
        else:
            try:
                st = os.stat(infile)
            except OSError:
                print "WARNING: Couldn't stat", infile + "...maybe it doesn't exist yet?"
                continue
            if (st.st_mtime > prev_mod_time):
                prev_mod_time = st.st_mtime
                need_update = True
        if need_update:
            board_teams = sumtime_reader.parse_board(sumtime)
            if not board_teams:
                prev_mod_time = 0
                print "WARNING: Failed to parse sumtime file.  This may just be a race condition, which is fine"
                continue
            else:
                if num_probs == -1:
                    num_probs = len(logged_teams[logged_teams.keys()[0]])
                write_board(destfile, board_teams, log_teams, num_probs)

#for line in f:
#    rec = parse(line)
#    log_update_time = 
#    while True:
        
#    sleep_time = 
#    if (sleep_time > 0):
#        print "Sleep for", sleep_time
#        time.sleep(sleep_time)
#    print "at", time.time()-start_time, rec


if __name__ == "__main__":
    main()
